/*
 * BOARD_CONST.java
 *
 * Created on 10. Dezember 2007, 12:19
 */

/*
 The contents of this file are subject to the
 Mozilla Public License Version 1.1 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at
 
 http://www.mozilla.org/MPL/
 
 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied.
 See the License for the specific language governing rights
 and limitations under the License.
 
 The Initial Developer of the Original Code is
 Georg-Johann Lay (GeorgJohann@web.de).
 
 Portions created by the Initial Developer are
 Copyright (C) 2007 Georg-Johann Lay. All Rights Reserved.
 
 Alternatively, the contents of this file may be used under the terms
 of either the GNU General Public License Version 3 or later (the "GPL"),
 or the GNU Lesser General Public License Version 3 or later (the "LGPL"),
 in which case the provisions of the GPL or the LGPL are applicable instead
 of those above.
 
 If you wish to allow use of your version of this file only
 under the terms of either the GPL or the LGPL, and not to allow others to
 use your version of this file under the terms of the MPL, indicate your
 decision by deleting the provisions above and replace them with the notice
 and other provisions required by the LGPL or the GPL. If you do not delete
 the provisions above, a recipient may use your version of this file under
 the terms of any one of the MPL, the GPL or the LGPL.
 */

package de.gjlay.chess;

/**
 * Board Constants
 * @author Georg-Johann Lay
 */
interface BOARD_CONST
{
    /**
     * ID of a bishop
     */
    static final int BISHOP = 3 << 1;

    /**
     * LSB of black pieces
     */
    static final int BLACK = 1;

    /**
     * ID of an empty field
     */
    static final int EMPTY = 0;

    /**
     * ID of a king
     */
    static final int KING = 6 << 1;

    /**
     * ID of a knight
     */
    static final int KNIGHT = 2 << 1;

    /**
     * ID of a pawn
     */
    static final int PAWN = 1 << 1;

    /**
     * ID of a queen
     */
    static final int QUEEN = 5 << 1;

    /**
     * ID of a rook
     */
    static final int ROOK = 4 << 1;


    /**
     * LSB of white pieces (or of {@link #EMPTY})
     */
    static final int WHITE = 0;


    /**
     * Character representations for pieces
     */
    public static final String PIECES_CHARS = ".BSLTDK";
}
