/*
 * Exercise.java
 *
 * Created on 11. Dezember 2007, 15:02
 */
/*
 The contents of this file are subject to the
 Mozilla Public License Version 1.1 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at
 
 http://www.mozilla.org/MPL/
 
 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied.
 See the License for the specific language governing rights
 and limitations under the License.
 
 The Initial Developer of the Original Code is
 Georg-Johann Lay (GeorgJohann@web.de).
 
 Portions created by the Initial Developer are
 Copyright (C) 2007 Georg-Johann Lay. All Rights Reserved.
 
 Alternatively, the contents of this file may be used under the terms
 of either the GNU General Public License Version 3 or later (the "GPL"),
 or the GNU Lesser General Public License Version 3 or later (the "LGPL"),
 in which case the provisions of the GPL or the LGPL are applicable instead
 of those above.
 
 If you wish to allow use of your version of this file only
 under the terms of either the GPL or the LGPL, and not to allow others to
 use your version of this file under the terms of the MPL, indicate your
 decision by deleting the provisions above and replace them with the notice
 and other provisions required by the LGPL or the GPL. If you do not delete
 the provisions above, a recipient may use your version of this file under
 the terms of any one of the MPL, the GPL or the LGPL.
 */

package de.gjlay.chess;

import de.gjlay.mobile.ui.SelectorLabel;

/**
 * Collection of some exercises
 * @author Georg-Johann Lay
 */
class Exercise
        implements BOARD_CONST
{
    static SelectorLabel[] LABELS;
    
    String name;
    int mover;
    int lastPawn2x;    
    String[] history;
    int mayCastle = 0;
    String wPieces;
    String bPieces;
    
    final static Exercise[] EXERCISES =
    {
        new Exercise ("Pillsbury I",
            0,
            false, false,
            "Ta1 Tg1 Lc3",
            false, false,
            "Kg8 Tc8 Tf8 f7 g7 h7",
            -1, new String[]
            {   "",
                /* 1 */ "g1g7", "g8h8",
                /* 2 */ "g7g8", "h8g8",
                /* 3 */ "a1g1"
            }),
        new Exercise ("Pillsbury II", 
            0,
            false, false,
            "Tg1 Lb2",
            false, false,
            "Kg8 Tf8 f7 g7 h7",
            -1,
            new String[] { null,
                /* 1 */ "g1g7", "g8h8",
                /* 2 */ "g7f7", "h8g8",
                /* 3 */ "f7g7", "g8h8",
                /* 4 */ "g7g1", "f8f6",
                /* 5 */ "b2f6"
            }),
        new Exercise ("Greco", 
            0,
            false, false,
            "Dh5 Lc4 Sg5",
            false, false,
            "Kg8 Tf8 f7 g7 h6",
            -1,
            new String[] { null,
                /* 1 */ "c4f7", "g8h8",
                /* 2 */ "h5g6", "h6g5",
                /* 3 */ "g6h5"
            }),
        new Exercise ("Anastasia", 
            0,
            false, false,
            "Ta1 Th1 Sd5",
            false, false,
            "Kg8 Tf8 f7 g7 h7",
            -1,
            new String[] { null,
                /* 1 */ "d5e7", "g8h8",
                /* 2 */ "h1h7", "h8h7",
                /* 3 */ "a1h1"
            }),
        new Exercise ("Lolli", 
            0,
            false, false,
            "De4 Te3 Ld4 f6",
            false, false,
            "Kg8 Tf8 Sd7 f7 g6 h7",
            -1,
            new String[] { null,
                /* 1 */ "e4f4", "g8h8",
                /* 2 */ "f4h6", "f8g8",
                /* 3 */ "h6h7", "h8h7",
                /* 4 */ "e3h3"
            }),
        new Exercise ("Noname I", 
            0,
            false, false,
            "Dh5 Lb2 Se5",
            false, false,
            "Kg8 Tf8 f7 g6 h7",
            -1,
            new String[] { null,
                /* 1 */ "e5g4", "g6h5",
                /* 2 */ "g4h6"
            }),
        new Exercise ("Noname II", 
            0,
            false, false,
            "Ld4 Se5",
            false, false,
            "Kh8 Tf8 e6 f7 h7",
            -1,
            new String[] { null,
                /* 1 */ "e5g6", "h8g8",
                /* 2 */ "g6e7"
            }),
        new Exercise ("Noname III", 
            0,
            false, false,
            "Te1 Te2 Lc1",
            false, false,
            "Kg8 Tf8 f7 g6 h7",
            -1,
            new String[] { null,
                /* 1 */ "c1h6", "f8d8",
                /* 2 */ "e2e8", "d8e8",
                /* 3 */ "e1e8"
            }),
        new Exercise ("Philidor", 
            0,
            false, false,
            "Dd1 Sg5",
            false, false,
            "Kg8 Te8 g7 h7",
            -1,
            new String[] { null,
                /* 1 */ "d1d5", "g8h8",
                /* 2 */ "g5f7", "h8g8",
                /* 3 */ "f7h6", "g8h8",
                /* 4 */ "d5g8", "e8g8",
                /* 5 */ "h6f7"
            }),
        new Exercise ("Damiano", 
            0,
            false, false,
            "Dc1 Te1 Th1 c4 g6",
            false, false,
            "Kg8 Tf8 f6 g7",
            -1,
            new String[] { null,
                /* 1 */ "h1h8", "g8h8",
                /* 2 */ "e1h1", "h8g8",
                /* 3 */ "h1h8", "g8h8",
                /* 4 */ "c1h1", "h8g8",
                /* 5 */ "h1h7"
            }),
        new Exercise ("Boden I", 
            0,
            false, false,
            "Kg1 Dc3 Tb1 Tf1 Le2 Lf4 a2 b2 f2 g2 h2",
            false, false,
            "Kc8 Dd8 Le6 Sd7 a7 b7 c6 f7 g7 h6",
            -1,
            new String[] { null,
                /* 1 */ "c3c6", "b7c6",
                /* 2 */ "e2a6"
            }),
        new Exercise ("Boden II", 
            0,
            false, false,
            "Kg1 Df3 Tb1 Tf1 Lf4 a2 c3 f2 g2 h2",
            false, false,
            "Kc8 Df6 Td7 Td8 Le6 a7 b7 c6 f7 g7 h6",
            -1,
            new String[] { null,
                /* 1 */ "f3c6", "b7c6",
                /* 2 */ "b1b8"
            })
            
    };
    
    private Exercise (String name, int mover,
            boolean w_0_0, boolean w_0_0_0, String wPieces,
            boolean b_0_0, boolean b_0_0_0, String bPieces,
            int lastPawn2x,
            String[] history)
    {
        this.name = name;
        this.mover = mover;
        this.lastPawn2x = lastPawn2x;
        this.history = history;
        this.wPieces = wPieces;
        this.bPieces = bPieces;
        
        if (w_0_0)    mayCastle |= Board.M_0_0[WHITE];
        if (w_0_0_0)  mayCastle |= Board.M_0_0_0[BLACK];
        if (b_0_0)    mayCastle |= Board.M_0_0[WHITE];
        if (b_0_0_0)  mayCastle |= Board.M_0_0_0[BLACK];
    }
    
    void fillBoard (Board b)
    {
        b.clear();
        
        b.mover      = mover;
        b.lastPawn2x = lastPawn2x;
        b.mayCastle  = mayCastle;
        
        setPieces (b, WHITE, wPieces);
        setPieces (b, BLACK, bPieces);
        
        b.setHistory (history);
    }
    
    void setPieces (Board b, int color, String str)
    {
        int piece;
        int pos = 0;
        
        while (pos < str.length())
        {
            int end = str.indexOf (' ', pos);
            if (-1 == end)
                end = str.length();
            
            piece = (end-pos == 2)
                    ? PAWN
                    : PIECES_CHARS.indexOf (str.charAt (pos++)) << 1;
            
            Field f = Field.Get (str.substring (pos));
            b.p[f.x][f.y] = piece | color;
            if (KING == piece)
                b.king[color] = f;
            
            pos = end+1;
        }
    }
    
    static
    {
        LABELS = new SelectorLabel[EXERCISES.length];

        for (int i=0; i < EXERCISES.length; i++)
            LABELS[i] = new SelectorLabel (i, EXERCISES[i].name);
    }
}
