/*
 * SelectListener.java
 *
 * Created on 27. November 2007, 01:29
 *
 */

/*
 The contents of this file are subject to the
 Mozilla Public License Version 1.1 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied.
 See the License for the specific language governing rights
 and limitations under the License.

 The Initial Developer of the Original Code is
 Georg-Johann Lay (GeorgJohann@web.de).

 Portions created by the Initial Developer are
 Copyright (C) 2007 Georg-Johann Lay. All Rights Reserved.

 Alternatively, the contents of this file may be used under the terms
 of either the GNU General Public License Version 3 or later (the "GPL"),
 or the GNU Lesser General Public License Version 3 or later (the "LGPL"),
 in which case the provisions of the GPL or the LGPL are applicable instead
 of those above.

 If you wish to allow use of your version of this file only
 under the terms of either the GPL or the LGPL, and not to allow others to
 use your version of this file under the terms of the MPL, indicate your
 decision by deleting the provisions above and replace them with the notice
 and other provisions required by the LGPL or the GPL. If you do not delete
 the provisions above, a recipient may use your version of this file under
 the terms of any one of the MPL, the GPL or the LGPL.
*/

package de.gjlay.mobile.ui;

/**
 * @see Selector
 * @see SelectorLabel
 * @author Georg-Johann Lay
 */
public interface SelectListener
{
    /** Fired if in item of {@link Selector} is selected.
     * @param id  The selected item's id,
     *            see {@link SelectorLabel#SelectorLabel(int,String)}.
     *            If the user selects "back", then <code>id</code> will be
     *            {@link Selector#BACK} which is -1.
     * @param tag The tag as passed in {@link Selector#Show(SelectListener,int,String,SelectorLabel[])}
     * @param index Selected element's index starting at 0 or -1 if BACK was selected.
     */
    public void selectionDone (int id, int tag, int index);
}
