/*
 * TextForm.java
 *
 * Created on 4. Dezember 2007, 11:38
 */
/*
 The contents of this file are subject to the
 Mozilla Public License Version 1.1 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied.
 See the License for the specific language governing rights
 and limitations under the License.

 The Initial Developer of the Original Code is
 Georg-Johann Lay (GeorgJohann@web.de).

 Portions created by the Initial Developer are
 Copyright (C) 2007 Georg-Johann Lay. All Rights Reserved.

 Alternatively, the contents of this file may be used under the terms
 of either the GNU General Public License Version 3 or later (the "GPL"),
 or the GNU Lesser General Public License Version 3 or later (the "LGPL"),
 in which case the provisions of the GPL or the LGPL are applicable instead
 of those above.

 If you wish to allow use of your version of this file only
 under the terms of either the GPL or the LGPL, and not to allow others to
 use your version of this file under the terms of the MPL, indicate your
 decision by deleting the provisions above and replace them with the notice
 and other provisions required by the LGPL or the GPL. If you do not delete
 the provisions above, a recipient may use your version of this file under
 the terms of any one of the MPL, the GPL or the LGPL.
 */

package de.gjlay.mobile.ui;

import de.gjlay.mobile.localize.L;
import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;

/**
 *
 * @author Georg-Johann Lay
 */
public class TextForm
        extends Form
        implements CommandListener
{
    private MIDlet midlet;
    private static TextForm instance;

    private int tag;
    private Command cancelCommand = null;
    private MessageListener listener;

    private TextForm (MIDlet midlet)
    {
        super ("");
        this.midlet = midlet;
        init();
    }

    public static TextForm GetInstance (MIDlet midlet)
    {
        return
            instance = new TextForm (midlet);
    }

    private void init()
    {
        setCommandListener (this);
    }

    public static void Show (MessageListener listener, int tag, String title, String text)
    {
        instance.listener = listener;
        instance.tag = tag;
        instance.show (text);
    }

    public static void Show (MessageListener listener, int tag, String title, String[][] items)
    {
        instance.listener = listener;
        instance.tag = tag;
        instance.deleteAll();
        instance.setTitle (title);
        instance.show (getStringItems (items));
    }

    private void show (String text)
    {
        append (text);
        
        removeCommand (cancelCommand);
        addCommand (cancelCommand = new Command (L._("T_BACK"), Command.CANCEL, 3));

        Display.getDisplay (midlet).setCurrent (this);
    }
    
    private void show (Item[] items)
    {
        for (int i=0; i<items.length; i++)
            append (items[i]);
        
        removeCommand (cancelCommand);
        addCommand (cancelCommand = new Command (L._("T_BACK"), Command.CANCEL, 3));

        Display.getDisplay (midlet).setCurrent (this);
    }

    public void commandAction (Command command, Displayable displayable)
    {
        listener.messageReturned (command.getCommandType(), tag);
    }

    private static StringItem[] getStringItems (String[][] strings)
    {
        StringItem[] items = new StringItem[strings.length];
        
        for (int i=0; i<items.length; i++)
                items[i] = new StringItem(strings[i][0], strings[i][1]);
        
        return items;
    }

}
